//
//  plat.h
//  mzfabric
//
//  Created by Breck H. Auten on 9/19/16.
//  Copyright © 2016 Markzware. All rights reserved.
//

#ifndef plat_h
#define plat_h

#import <sys/sysctl.h>
#import "appkey.h"

#define MIN_MACOSX_VERSION 10
#define MIN_DARWIN_VERSION	5

//12.x.x  OS X 10.8.x Mountain Lion
//11.x.x  OS X 10.7.x Lion
//10.x.x  OS X 10.6.x Snow Leopard
//9.x.x  OS X 10.5.x Leopard
//8.x.x  OS X 10.4.x Tiger
//7.x.x  OS X 10.3.x Panther
//6.x.x  OS X 10.2.x Jaguar
//5.x    OS X 10.1.x Puma
bool __GetPlat(int theMinVer=MIN_MACOSX_VERSION);

inline static bool _getPlat(int theMinVer=MIN_MACOSX_VERSION)
{
    char str[256];
    size_t size = sizeof(str);
    sysctlbyname("kern.osrelease", str, &size, NULL, 0);
    
    int		versionNum = 0;
    int		i = 0;
    
    while (str[i] >= '0' && str[i] <= '9')
    {
        versionNum *= 10;
        versionNum += (str[i] & 0x0F);
        i++;
    }
    // versionNum->derivedVer. 10 is assumed major version
    // Map 5->1, 6->2, 7->3...
    // int     derivedVer = 0;
    if(versionNum < MIN_DARWIN_VERSION)
    {
        versionNum = MIN_DARWIN_VERSION;
    }
    versionNum -= 4;
    
    return (versionNum >= theMinVer);
}

#endif /* plat_h */
